// C Source File
// Created 3/20/2003; 9:49:15 PM

#define USE_TI89              // Produce .89z File
#define USE_TI92PLUS          // Produce .9xz File

#define OPTIMIZE_ROM_CALLS    // Use ROM Call Optimization

#define SAVE_SCREEN           // Save/Restore LCD Contents

#include <tigcclib.h>         // Include All Header Files

// Main Function
static unsigned char mine[]={0b00011000,
                             0b01011010,
                             0b00111100,
                             0b11111111,
                             0b11111111,
                             0b00111100,
                             0b01011010,
                             0b00011000};
static unsigned char flag[]={0b11100000,
                             0b11110000,
                             0b11111000,
                             0b10000000,
                             0b10000000,
                             0b10000000};
static unsigned char incorrect[]={0b10000100,
                                  0b01001000,
                                  0b00110000,
                                  0b00110000,
                                  0b01001000,
                                  0b10000100};
static unsigned char buttonuplight[]={0b10000000,
                                      0b10000000,
                                      0b10000000,
                                      0b10000000,
                                      0b10000000,
                                      0b10000000,
                                      0b10000000,
                                      0b11111111};
static unsigned char buttonupdark[]={0b11111111,
                                     0b10000001,
                                     0b10000001,
                                     0b10000001,
                                     0b10000001,
                                     0b10000001,
                                     0b10000001,
                                     0b11111111};
static unsigned char clear[]={0b00000000,
                              0b00000000,
                              0b00000000,
                              0b00000000,
                              0b00000000,
                              0b00000000,
                              0b00000000};
static unsigned short cursoricon[]={0b1111111111000000,
                                    0b1000000001000000,
                                    0b1000000001000000,
                                    0b1000000001000000,
                                    0b1000000001000000,
                                    0b1000000001000000,
                                    0b1000000001000000,
                                    0b1000000001000000,
                                    0b1000000001000000,
                                    0b1111111111000000};
static unsigned short cursorclear[]={0b0000000000111111,
                                     0b0000000000111111,
                                     0b0000000000111111,
                                     0b0000000000111111,
                                     0b0000000000111111,
                                     0b0000000000111111,
                                     0b0000000000111111,
                                     0b0000000000111111,
                                     0b0000000000111111,
                                     0b0000000000111111};
int fieldsize=20;
int minefield[20][20];
int minefieldnumbers[20][20];
int minefielddisplay[2];
int checkingfield[20][20];
int cursor[4];
int fieldpos[2];
int redraw[3];
int i=0;
int j=0;
int bombn=0;
int flags=0;
int quitnow=0;
int gameover=0;
float time=0.0;
float timechange=0.0;
float besttime[3]={99999.9,99999.9,99999.9};
void _main(void)
{
	INT_HANDLER save_int_1;
	save_int_1 = GetIntVec (AUTO_INT_1);
	SetIntVec (AUTO_INT_1, DUMMY_HANDLER);
	GrayOn();
	time=0.0;
	quitnow=0;
	runmenu();
  SetPlane(DARK_PLANE);
  clrscr();
  SetPlane(LIGHT_PLANE);
  clrscr();
  int offset=9;
  int keydelay=0;
  cursor[0]=0;  //cursor x position on the 10x10 displayed region
  cursor[1]=0;  //cursor y position on the 10x10 displayed region
  redraw[0]=0;  //x-coord of block to be redrawn for single redraw
  redraw[1]=0;  //y-coord of block to be redrawn for single redraw
  redraw[2]=2;  //1 means 1 block needs to be redrawn, 2 means whole board needs a redraw
  fieldpos[0]=0;  //x position in total mine field
  fieldpos[1]=0;  //y position in total mine field
  minefielddisplay[0]=0;  //x position of the top left corner of displayed 10x10 sqare in the actual field
  minefielddisplay[1]=0;  //y position of the above
  flags=0;
  timechange=0.1;
  gameover=0;
	top:
	if(quitnow==1) goto exitgame;
	time=time+timechange;
  SetPlane (LIGHT_PLANE);
	DrawLine(offset-1,offset-1,offset-1,offset+89,A_NORMAL);
	DrawLine(offset-1,offset-1,offset+89,offset-1,A_NORMAL);
	DrawLine(offset-1,offset+89,offset+89,offset+89,A_NORMAL);
	DrawLine(offset+89,offset-1,offset+89,offset+89,A_NORMAL);
	SetPlane(DARK_PLANE);
	if(redraw[2]!=0){
		FontSetSys(F_4x6);
		for(i=0;i<10;i++){
			for(j=0;j<10;j++){
				if((minefield[i+minefielddisplay[0]][j+minefielddisplay[1]]==0&&redraw[2]==2)||(minefield[i+minefielddisplay[0]][j+minefielddisplay[1]]==0&&redraw[0]==i+minefielddisplay[0]&&redraw[1]==j+minefielddisplay[1]&&redraw[2]==1)){
					Sprite8(i*9+offset,j*9+offset,8,clear,GetPlane(DARK_PLANE),SPRT_AND);
		 			Sprite8(i*9+offset,j*9+offset,8,clear,GetPlane(LIGHT_PLANE),SPRT_AND);
					Sprite8(i*9+offset,j*9+offset,8,buttonuplight,GetPlane(LIGHT_PLANE),SPRT_OR);
					Sprite8(i*9+offset,j*9+offset,8,buttonupdark,GetPlane(DARK_PLANE),SPRT_OR);
				}else if((minefield[i+minefielddisplay[0]][j+minefielddisplay[1]]==1&&redraw[2]==2)||(minefield[i+minefielddisplay[0]][j+minefielddisplay[1]]==1&&redraw[0]==i+minefielddisplay[0]&&redraw[1]==j+minefielddisplay[1]&&redraw[2]==1)){
					Sprite8(i*9+offset,j*9+offset,8,clear,GetPlane(DARK_PLANE),SPRT_AND);
 					Sprite8(i*9+offset,j*9+offset,8,clear,GetPlane(LIGHT_PLANE),SPRT_AND);
					if(minefieldnumbers[i+minefielddisplay[0]][j+minefielddisplay[1]]!=0){
						SetPlane(DARK_PLANE);
						printf_xy(i*9+offset+2,j*9+offset+2,"%d",minefieldnumbers[i+minefielddisplay[0]][j+minefielddisplay[1]]);
						SetPlane(LIGHT_PLANE);
						printf_xy(i*9+offset+2,j*9+offset+2,"%d",minefieldnumbers[i+minefielddisplay[0]][j+minefielddisplay[1]]);
					}
				}else if((minefield[i+minefielddisplay[0]][j+minefielddisplay[1]]==2&&redraw[2]==2)||(minefield[i+minefielddisplay[0]][j+minefielddisplay[1]]==2&&redraw[0]==i+minefielddisplay[0]&&redraw[1]==j+minefielddisplay[1]&&redraw[2]==1)){
					Sprite8(i*9+offset,j*9+offset,8,clear,GetPlane(LIGHT_PLANE),SPRT_AND);
					Sprite8(i*9+offset,j*9+offset,8,clear,GetPlane(DARK_PLANE),SPRT_AND);
					Sprite8(i*9+offset,j*9+offset,8,buttonuplight,GetPlane(LIGHT_PLANE),SPRT_OR);
					Sprite8(i*9+offset,j*9+offset,8,buttonupdark,GetPlane(DARK_PLANE),SPRT_OR);
					Sprite8(i*9+offset+2,j*9+offset+1,6,flag,GetPlane(LIGHT_PLANE),SPRT_OR);
					Sprite8(i*9+offset+2,j*9+offset+1,6,flag,GetPlane(DARK_PLANE),SPRT_OR);
				}else if((minefield[i+minefielddisplay[0]][j+minefielddisplay[1]]==3&&redraw[2]==2)||(minefield[i+minefielddisplay[0]][j+minefielddisplay[1]]==3&&redraw[0]==i+minefielddisplay[0]&&redraw[1]==j+minefielddisplay[1]&&redraw[2]==1)){
					Sprite8(i*9+offset,j*9+offset,8,clear,GetPlane(LIGHT_PLANE),SPRT_AND);
					Sprite8(i*9+offset,j*9+offset,8,clear,GetPlane(DARK_PLANE),SPRT_AND);
					Sprite8(i*9+offset,j*9+offset,8,mine,GetPlane(LIGHT_PLANE),SPRT_OR);
					Sprite8(i*9+offset,j*9+offset,8,mine,GetPlane(DARK_PLANE),SPRT_OR);
				}else if((minefield[i+minefielddisplay[0]][j+minefielddisplay[1]]==4&&redraw[2]==2)||(minefield[i+minefielddisplay[0]][j+minefielddisplay[1]]==4&&redraw[0]==i+minefielddisplay[0]&&redraw[1]==j+minefielddisplay[1]&&redraw[2]==1)){
					Sprite8(i*9+offset,j*9+offset,8,clear,GetPlane(LIGHT_PLANE),SPRT_AND);
					Sprite8(i*9+offset,j*9+offset,8,clear,GetPlane(DARK_PLANE),SPRT_AND);
					Sprite8(i*9+offset+1,j*9+offset+1,6,incorrect,GetPlane(LIGHT_PLANE),SPRT_OR);
					Sprite8(i*9+offset+1,j*9+offset+1,6,incorrect,GetPlane(DARK_PLANE),SPRT_OR);
				}
			}
		}
		redraw[2]=0;
	}
	Sprite16(cursor[0]*9+offset-1,cursor[1]*9+offset-1,10,cursoricon,GetPlane(LIGHT_PLANE),SPRT_OR);
	Sprite16(cursor[0]*9+offset-1,cursor[1]*9+offset-1,10,cursoricon,GetPlane(DARK_PLANE),SPRT_OR);
	FontSetSys(F_4x6);
	if(minefielddisplay[0]<10){
		SetPlane(DARK_PLANE);
		printf_xy(8,3,"%d  ",minefielddisplay[0]);
		SetPlane(LIGHT_PLANE);
		printf_xy(8,3,"%d  ",minefielddisplay[0]);
	}else{
		SetPlane(DARK_PLANE);
		printf_xy(8,3,"%d",minefielddisplay[0]);
		SetPlane(LIGHT_PLANE);
		printf_xy(8,3,"%d",minefielddisplay[0]);
	}
	if(minefielddisplay[1]<10){
		SetPlane(DARK_PLANE);
		printf_xy(0,8,"  %d",minefielddisplay[1]);
		SetPlane(LIGHT_PLANE);
		printf_xy(0,8,"  %d",minefielddisplay[1]);
	}else{
		SetPlane(DARK_PLANE);
		printf_xy(0,8,"%d",minefielddisplay[1]);
		SetPlane(LIGHT_PLANE);
		printf_xy(0,8,"%d",minefielddisplay[1]);
	}	
	SetPlane(DARK_PLANE);
	FontSetSys(F_6x8);
	printf_xy(105,5,"Mine");
	printf_xy(115,14,"Sweeper");
	FontSetSys(F_4x6);
	printf_xy(105,40,"Flags Left: %d  ",bombn-flags);
	printf_xy(105,80,"Time: %f",time);
	SetPlane(LIGHT_PLANE);
	FontSetSys(F_6x8);
	printf_xy(105,5,"Mine");
	printf_xy(115,14,"Sweeper");
	FontSetSys(F_4x6);
	printf_xy(105,40,"Flags Left: %d  ",bombn-flags);
	printf_xy(105,80,"Time: %f",time);	
	fieldpos[0]=cursor[0]+minefielddisplay[0];
	fieldpos[1]=cursor[1]+minefielddisplay[1];
	SetPlane(DARK_PLANE);
	if(keydelay>0){
		keydelay=keydelay-1;
	}
	if(_rowread(0b11111110)&(0b00000001)){
		Sprite16(cursor[0]*9+offset-1,cursor[1]*9+offset-1,10,cursorclear,GetPlane(LIGHT_PLANE),SPRT_AND);
		Sprite16(cursor[0]*9+offset-1,cursor[1]*9+offset-1,10,cursorclear,GetPlane(DARK_PLANE),SPRT_AND);
		cursor[1]=cursor[1]-1; //move up
		redraw[0]=fieldpos[0];
		redraw[1]=fieldpos[1];
		redraw[2]=1;
		if(cursor[1]<0){
			cursor[1]=0;
			minefielddisplay[1]=minefielddisplay[1]-1;
			redraw[2]=2;
			if(minefielddisplay[1]<0){
				minefielddisplay[1]=0;
			}
		}
	}else if(_rowread(0b11111110)&(0b00000100)){
		Sprite16(cursor[0]*9+offset-1,cursor[1]*9+offset-1,10,cursorclear,GetPlane(LIGHT_PLANE),SPRT_AND);
		Sprite16(cursor[0]*9+offset-1,cursor[1]*9+offset-1,10,cursorclear,GetPlane(DARK_PLANE),SPRT_AND);
		cursor[1]=cursor[1]+1; //move down
		redraw[0]=fieldpos[0];
		redraw[1]=fieldpos[1];
		redraw[2]=1;
		if(cursor[1]>9){
			cursor[1]=9;
			minefielddisplay[1]=minefielddisplay[1]+1;
			redraw[2]=2;
			if(minefielddisplay[1]>fieldsize-10){
				minefielddisplay[1]=fieldsize-10;
			}
		}
	}else if(_rowread(0b11111110)&(0b00000010)){
		Sprite16(cursor[0]*9+offset-1,cursor[1]*9+offset-1,10,cursorclear,GetPlane(LIGHT_PLANE),SPRT_AND);
		Sprite16(cursor[0]*9+offset-1,cursor[1]*9+offset-1,10,cursorclear,GetPlane(DARK_PLANE),SPRT_AND);
		cursor[0]=cursor[0]-1; //move left
		redraw[0]=fieldpos[0];
		redraw[1]=fieldpos[1];
		redraw[2]=1;
		if(cursor[0]<0){
			cursor[0]=0;
			minefielddisplay[0]=minefielddisplay[0]-1;
			redraw[2]=2;
			if(minefielddisplay[0]<0){
				minefielddisplay[0]=0;
			}
		}
	}else if(_rowread(0b11111110)&(0b00001000)){
		Sprite16(cursor[0]*9+offset-1,cursor[1]*9+offset-1,10,cursorclear,GetPlane(LIGHT_PLANE),SPRT_AND);
		Sprite16(cursor[0]*9+offset-1,cursor[1]*9+offset-1,10,cursorclear,GetPlane(DARK_PLANE),SPRT_AND);
		cursor[0]=cursor[0]+1; //move right
		redraw[0]=fieldpos[0];
		redraw[1]=fieldpos[1];
		redraw[2]=1;
		if(cursor[0]>9){
			cursor[0]=9;
			minefielddisplay[0]=minefielddisplay[0]+1;
			redraw[2]=2;
			if(minefielddisplay[0]>fieldsize-10){
				minefielddisplay[0]=fieldsize-10;
			}
		}
	}else if(_rowread(0b11111110)&(0b00010000)&&minefield[fieldpos[0]][fieldpos[1]]==0&&keydelay==0){
		redraw[0]=fieldpos[0];
		redraw[1]=fieldpos[1];
		redraw[2]=1;		
		minefield[fieldpos[0]][fieldpos[1]]=1;  //set to down
		checkbox(fieldpos[0],fieldpos[1]);
		keydelay=3;
	}else if(_rowread(0b11111110)&(0b01000000)&&minefield[fieldpos[0]][fieldpos[1]]==0&&keydelay==0){
		redraw[0]=fieldpos[0];
		redraw[1]=fieldpos[1];
		redraw[2]=1;
		minefield[fieldpos[0]][fieldpos[1]]=2;  //set to flagged
		flags=flags+1;
		keydelay=3;
	}else if(_rowread(0b11111110)&(0b01000000)&&minefield[fieldpos[0]][fieldpos[1]]==2&&keydelay==0){
		redraw[0]=fieldpos[0];
		redraw[1]=fieldpos[1];
		redraw[2]=1;
		minefield[fieldpos[0]][fieldpos[1]]=0;  //set to unflagged
		flags=flags-1;
		keydelay=3;
	}else if(_rowread(0b10111111)&(0b00000001)){
		runmenu();
	}
	for(i=0;i<300;i++){
		for(j=0;j<300;j++){
			//this is for delay purposes
		}
	}
	goto top;
	exitgame:
	GrayOff();
	SetIntVec (AUTO_INT_1, save_int_1);
}
generatelevel(){
	SetPlane(LIGHT_PLANE);
	clrscr();
	SetPlane(DARK_PLANE);
	clrscr();
	randomize();
	for(i=0;i<fieldsize;i++){
		for(j=0;j<fieldsize;j++){
			checkingfield[i][j]=0;
		}
	}
	for(i=0;i<fieldsize;i++){
		for(j=0;j<fieldsize;j++){
			minefieldnumbers[i][j]=0;
			minefield[i][j]=0;
		}
	}
	clrscr();
	i=0;
	int bposx=1;
	int bposy=1;
	int temp=0;
	bombn=(int) ((fieldsize)*(fieldsize))/5;
	while(i<bombn){
		bposx=random(fieldsize);
		bposy=random(fieldsize);
		if(minefieldnumbers[bposx][bposy]==0){
			minefieldnumbers[bposx][bposy]=9;
			i=i+1;
			printf_xy(10,10,"%d bombs generated...",i);
		}
	}
	for(i=0;i<fieldsize;i++){
		for(j=0;j<fieldsize;j++){
			if(minefieldnumbers[i][j]!=9){
				temp=0;
				if(minefieldnumbers[i-1][j-1]==9&&i>0&&j>0){
					temp=temp+1;
				}
				if(minefieldnumbers[i][j-1]==9&&j>0){
					temp=temp+1;
				}
				if(minefieldnumbers[i+1][j-1]==9&&i<fieldsize-1&&j>0){
					temp=temp+1;
				}
				if(minefieldnumbers[i-1][j]==9&&i>0){
					temp=temp+1;
				}
				if(minefieldnumbers[i+1][j]==9&&i<fieldsize-1){
					temp=temp+1;
				}
				if(minefieldnumbers[i-1][j+1]==9&&i>0&&j<fieldsize-1){
					temp=temp+1;
				}
				if(minefieldnumbers[i][j+1]==9&&j<fieldsize-1){
					temp=temp+1;
				}
				if(minefieldnumbers[i+1][j+1]==9&&i<fieldsize-1&&j<fieldsize-1){
					temp=temp+1;
				}
				minefieldnumbers[i][j]=temp;
			}
		}
	}
}
checkbox(int xpos, int ypos){
	checkingfield[xpos][ypos]=2;
	checkloop(xpos,ypos);
	int checkingfieldtotal=0;
	do{
		checkingfieldtotal=0;
		for(i=0;i<fieldsize;i++){
			for(j=0;j<fieldsize;j++){
				if(checkingfield[i][j]==1){
					checkingfield[i][j]=2;
					checkingfieldtotal=1;
					checkloop(i,j);
				}
			}
		}
	}while(checkingfieldtotal>0);
	checkforcompleted();
}
checkloop(int xpos, int ypos){
	if(minefieldnumbers[xpos][ypos]==9){
		minefield[xpos][ypos]=3;  //set to mine
		gameover=1;
		endingsequence();
	}else	if(minefieldnumbers[xpos][ypos]>=1&&minefieldnumbers[xpos][ypos]<=8){
		minefield[xpos][ypos]=1;  //set to show number
	}else	if(minefieldnumbers[xpos][ypos]==0){
		redraw[2]=2;
		if(xpos>0&&ypos>0){
			if(minefield[xpos-1][ypos-1]==0){
				minefield[xpos-1][ypos-1]=1;
			}
			if(checkingfield[xpos-1][ypos-1]!=2){
				checkingfield[xpos-1][ypos-1]=1;
			}
		}
		if(ypos>0){
			if(minefield[xpos][ypos-1]==0){
				minefield[xpos][ypos-1]=1;
			}
			if(checkingfield[xpos][ypos-1]!=2){
				checkingfield[xpos][ypos-1]=1;
			}
		}
		if(xpos<fieldsize-1&&ypos>0){
			if(minefield[xpos+1][ypos-1]==0){
				minefield[xpos+1][ypos-1]=1;
			}
			if(checkingfield[xpos+1][ypos-1]!=2){
				checkingfield[xpos+1][ypos-1]=1;
			}
		}
		if(xpos>0){
			if(minefield[xpos-1][ypos]==0){
				minefield[xpos-1][ypos]=1;
			}
			if(checkingfield[xpos-1][ypos]!=2){
				checkingfield[xpos-1][ypos]=1;
			}
		}
		if(xpos<fieldsize-1){
			if(minefield[xpos+1][ypos]==0){
				minefield[xpos+1][ypos]=1;
			}
			if(checkingfield[xpos+1][ypos]!=2){
				checkingfield[xpos+1][ypos]=1;
			}
		}
		if(xpos>0&&ypos<fieldsize-1){
			if(minefield[xpos-1][ypos+1]==0){
				minefield[xpos-1][ypos+1]=1;
			}
			if(checkingfield[xpos-1][ypos+1]!=2){
				checkingfield[xpos-1][ypos+1]=1;
			}
		}
		if(ypos<fieldsize-1){
			if(minefield[xpos][ypos+1]==0){
				minefield[xpos][ypos+1]=1;
			}
			if(checkingfield[xpos][ypos+1]!=2){
				checkingfield[xpos][ypos+1]=1;
			}
		}
		if(xpos<fieldsize-1&&ypos<fieldsize-1){
			if(minefield[xpos+1][ypos+1]==0){
				minefield[xpos+1][ypos+1]=1;
			}
			if(checkingfield[xpos+1][ypos+1]!=2){
				checkingfield[xpos+1][ypos+1]=1;
			}
		}
	}
}
endingsequence(){
	for(i=0;i<fieldsize;i++){
		for(j=0;j<fieldsize;j++){
			if(minefieldnumbers[i][j]==9&&minefield[i][j]!=2){
				minefield[i][j]=3;
			}else if(minefield[i][j]==2&&minefieldnumbers[i][j]!=9){
				minefield[i][j]=4;
			}else if(minefieldnumbers[i][j]>=0&&minefieldnumbers[i][j]<=8){
				minefield[i][j]=1;
			}
		}
	}
	redraw[2]=2;
	timechange=0.0;
	FontSetSys(F_4x6);
	SetPlane(LIGHT_PLANE);
	printf_xy(110,60,"You Lost!");
	SetPlane(DARK_PLANE);
	printf_xy(110,60,"You Lost!");
	FontSetSys(F_4x6);
}
checkforcompleted(){
	int totaluncovered=0;
	for(i=0;i<fieldsize;i++){
		for(j=0;j<fieldsize;j++){
			if(minefield[i][j]==1){
				totaluncovered++;
			}
		}
	}
	if(totaluncovered==((fieldsize)*(fieldsize))-bombn&&gameover!=1){
		SetPlane(DARK_PLANE);
		FontSetSys(F_4x6);
		printf_xy(110,60,"You Won!");
		SetPlane(LIGHT_PLANE);
		printf_xy(110,60,"You Won!");
		timechange=0.0;
		int bestcheck=0;
		if(fieldsize==10){
			if(time<besttime[0]){
				besttime[0]=time;
				bestcheck=1;
			}
		}else if(fieldsize==15){
			if(time<besttime[1]){
				besttime[1]=time;
				bestcheck=1;
			}
		}else if(fieldsize==20){
			if(time<besttime[2]){
				besttime[2]=time;
				bestcheck=1;
			}
		}
		if(bestcheck==1){
		SetPlane(DARK_PLANE);
		FontSetSys(F_4x6);
		printf_xy(100,70,"New Best Time!");
		SetPlane(LIGHT_PLANE);
		printf_xy(100,70,"New Best Time!");			
		}
	}
}
runmenu(){
	int selection[2]={0,1};
	topofmenu:
	FontSetSys(F_6x8);
	if(selection[1]!=selection[0]){
		SetPlane(LIGHT_PLANE);
		clrscr();
		SetPlane(DARK_PLANE);
		clrscr();
		SetPlane(DARK_PLANE);
		printf_xy(20,40,"Start New Game");
		printf_xy(20,50,"Resume Current Game");
		printf_xy(20,60,"View Best Times");
		printf_xy(20,70,"Exit Game");
		SetPlane(LIGHT_PLANE);
		if(selection[0]==0){
			printf_xy(20,40,"Start New Game");
			selection[1]=0;
		}
		if(selection[0]==1){
			printf_xy(20,50,"Resume Current Game");
			selection[1]=1;
		}
		if(selection[0]==2){
			printf_xy(20,60,"View Best Times");
			selection[1]=2;
		}
		if(selection[0]==3){
			printf_xy(20,70,"Exit Game");
			selection[1]=3;
		}
	}
	for(i=0;i<250;i++){
		for(j=0;j<200;j++){
			//this is for delay purposes
		}
	}
	if(_rowread(0b11111110)&(0b00000001)){
		selection[0]=selection[0]-1;
		if(selection[0]<0) selection[0]=3;
		if(selection[0]==1&&time==0) selection[0]=0;
	}else if(_rowread(0b11111110)&(0b00000100)){
		selection[0]=selection[0]+1;
		if(selection[0]>3) selection[0]=0;
		if(selection[0]==1&&time==0) selection[0]=2;
	}else if(_rowread(0b11111110)&(0b00010000)){
		goto selectionmade;
	}else if(_rowread(0b10111111)&(0b00000001)){
		selection[0]=3;
		goto selectionmade;
	}
	goto topofmenu;
	selectionmade:
	FontSetSys(F_4x6);
	if(selection[0]==0){
		selection[1]=1;
		int choosing=1;
		while(choosing==1){
			if(selection[0]!=selection[1]){
				SetPlane(LIGHT_PLANE);
				clrscr();
				SetPlane(DARK_PLANE);
				clrscr();
				SetPlane(DARK_PLANE);
				printf_xy(20,40,"10x10 Field");
				printf_xy(20,50,"15x15 Field");
				printf_xy(20,60,"20x20 Field");
				SetPlane(LIGHT_PLANE);
				if(selection[0]==0){
					printf_xy(20,40,"10x10 Field");
					selection[1]=0;
				}else if(selection[0]==1){
					printf_xy(20,50,"15x15 Field");
					selection[1]=1;
				}else	if(selection[0]==2){
					printf_xy(20,60,"20x20 Field");
					selection[1]=2;
				}
			}
			for(i=0;i<250;i++){
				for(j=0;j<200;j++){
					//this is for delay purposes
				}
			}
			if(_rowread(0b11111110)&(0b00000001)){
				selection[0]=selection[0]-1;
				if(selection[0]<0) selection[0]=2;
			}else if(_rowread(0b11111110)&(0b00000100)){
				selection[0]=selection[0]+1;
				if(selection[0]>2) selection[0]=0;
			}else if(_rowread(0b11111110)&(0b00010000)){
				if(selection[0]==0) fieldsize=10;
				if(selection[0]==1) fieldsize=15;
				if(selection[0]==2) fieldsize=20;
				choosing=0;
			}
		}
		generatelevel();
		SetPlane(LIGHT_PLANE);
		clrscr();
		SetPlane(DARK_PLANE);
		clrscr();
	  cursor[0]=0;  //cursor x position on the 10x10 displayed region
	  cursor[1]=0;  //cursor y position on the 10x10 displayed region
	  redraw[0]=0;  //x-coord of block to be redrawn for single redraw
	  redraw[1]=0;  //y-coord of block to be redrawn for single redraw
	  redraw[2]=2;  //1 means 1 block needs to be redrawn, 2 means whole board needs a redraw
	  fieldpos[0]=0;  //x position in total mine field
	  fieldpos[1]=0;  //y position in total mine field
	  minefielddisplay[0]=0;  //x position of the top left corner of displayed 10x10 sqare in the actual field
	  minefielddisplay[1]=0;  //y position of the above
	  flags=0;
	  time=0.0;
	  timechange=0.1;
	  gameover=0;
		return;
	}
	if(selection[0]==1){
		redraw[2]=2;
		SetPlane(LIGHT_PLANE);
		clrscr();
		SetPlane(DARK_PLANE);
		clrscr();
		return;
	}
	if(selection[0]==2){
		SetPlane(LIGHT_PLANE);
		clrscr();
		SetPlane(DARK_PLANE);
		clrscr();
		FontSetSys(F_6x8);
		SetPlane(LIGHT_PLANE);
		printf_xy(30,20,"Best Times");
		SetPlane(DARK_PLANE);
		printf_xy(30,20,"Best Times");
		FontSetSys(F_4x6);
		printf_xy(30,35,"10x10: %f",besttime[0]);
		printf_xy(30,45,"15x15: %f",besttime[1]);
		printf_xy(30,55,"20x20: %f",besttime[2]);
		SetPlane(LIGHT_PLANE);
		printf_xy(30,35,"10x10: %f",besttime[0]);
		printf_xy(30,45,"15x15: %f",besttime[1]);
		printf_xy(30,55,"20x20: %f",besttime[2]);
		int waiting=1;
		for(i=0;i<250;i++){
			for(j=0;j<200;j++){
				//this is for delay purposes
			}
		}
		while(waiting==1){
			if(_rowread(0b11111110)&(0b00010000)){
				waiting=0;
			}
		}
		for(i=0;i<250;i++){
			for(j=0;j<200;j++){
				//this is for delay purposes
			}
		}
		selection[0]=0;
		selection[1]=1;
		goto topofmenu;
	}
	if(selection[0]==3){
		quitnow=1;
	}
}
